## org.apache.jasper
Class JspCompilationContext

    java.lang.Object
      org.apache.jasper.JspCompilationContext

    public class JspCompilationContext

extends Object

A place holder for various things that are used through out the JSP engine. This is a per-request/per-context data structure. Some of the instance variables are set at different points. Most of the path-related stuff is here - mangling names, versions, dirs, loading resources and dealing with uris.

Author:
  Anil K. Vijendran, Harish Prabandham, Pierre Delisle, Costin Manolache, Kin-man Chung

Constructor Summary
`JspCompilationContext(String jspUri, boolean isErrPage, Options options, ServletContext context, JspServletWrapper jsw, JspRuntimeContext rctxt)`
`JspCompilationContext(String tagfile, TagInfo tagInfo, Options options, ServletContext context, JspServletWrapper jsw, JspRuntimeContext rctxt, URL tagFileJarUrl)`

Method Summary
`void` `addTaglib(String uri, TagLibraryInfoImpl taglib)` Adds the given tag library with the given URI to the context-wide tag library cache.
`void` `clearTagFileJarUrls()` Clears the context-wide mappings from JAR packaged tag file paths to their corresponding URLs.
`void` `clearTaglibs()` Clears the context-wide tag library cache.
`void` `compile()`
`Compiler` `createCompiler(boolean jspcMode)` Create a "Compiler" object.
`Compiler` `createParser()` Create a compiler object for parsing only.
`String` `getClassFileName()`
`ClassLoader` `getClassLoader()` What class loader to use for loading classes while compiling this JSP?
`String` `getClassPath()` The classpath that is passed off to the Java compiler.
`Compiler` `getCompiler()`
`String` `getContentType()` Get the content type of this JSP.
`String` `getFullClassName()` Full class name
`String` `getJavaPath()` Path of the Java file relative to the work directory.
`String` `getJspFile()` Path of the JSP URI.
`ClassLoader` `getJspLoader()`
`Options` `getOptions()` Get hold of the Options object for this context.
`String` `getOutputDir()` The output directory to generate code into.
`String` `getRealPath(String path)` Gets the actual path of a URI relative to the context of the compilation.
`URL` `getResource(String res)`
`InputStream` `getResourceAsStream(String res)` Gets a resource as a stream, relative to the meanings of this context's implementation.
`Set` `getResourcePaths(String path)`
`JspRuntimeContext` `getRuntimeContext()`
`String` `getServletClassName()` Just the class name (does not include package name) of the generated class.
`ServletContext` `getServletContext()`
`String` `getServletJavaFileName()` Full path name of the Java file into which the servlet is being generated.
`String` `getServletPackageName()` Package name for the generated class is make up of the base package name, which is user settable, and the derived package name.
`URL` `getTagFileJarUrl()` Returns the JAR file in which the tag file for which this JspCompilationContext was created is packaged, or null if this JspCompilationContext does not correspond to a tag file, or if the corresponding tag file is not packaged in a JAR.
`ConcurrentHashMap<String,URL>` `getTagFileJarUrls()` Gets the context-wide mappings from JAR packaged tag file paths to their corresponfing URLs.
`TagInfo` `getTagInfo()`
`ConcurrentHashMap<String,TagLibraryInfoImpl>` `getTaglibs()` Gets the context-wide tag library cache.
`String[]` `getTldLocation(String uri)` Gets the 'location' of the TLD associated with the given taglib 'uri'.
`ServletWriter` `getWriter()` Where is the servlet being generated?
`void` `incrementRemoved()`
`boolean` `isErrorPage()` Are we processing something that has been declared as an errorpage?
`boolean` `isPrototypeMode()` True if we are compiling a tag file in prototype mode.
`boolean` `isRemoved()`
`boolean` `isTagFile()`
`boolean` `keepGenerated()` Are we keeping generated code around?
`Class` `load()`
`void` `makeOutputDir()`
`String` `resolveRelativeUri(String uri)` Get the full value of a URI relative to this compilations context uses current file as the base.
`void` `setClassLoader(URLClassLoader loader)`
`void` `setClassPath(String classPath)` The classpath that is passed off to the Java compiler.
`void` `setContentType(String contentType)`
`void` `setErrorPage(boolean isErrPage)`
`void` `setPrototypeMode(boolean pm)`
`void` `setServletClassName(String className)`
`void` `setServletPackageName(String servletPackageName)` The package name into which the servlet class is generated.
`void` `setTagInfo(TagInfo tagi)`
`void` `setWriter(ServletWriter writer)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### JspCompilationContext

    public JspCompilationContext(String jspUri,
                                 boolean isErrPage,
                                 Options options,
                                 ServletContext context,
                                 JspServletWrapper jsw,
                                 JspRuntimeContext rctxt)
                          throws JasperException

Throws:
  `JasperException`

### JspCompilationContext

    public JspCompilationContext(String tagfile,
                                 TagInfo tagInfo,
                                 Options options,
                                 ServletContext context,
                                 JspServletWrapper jsw,
                                 JspRuntimeContext rctxt,
                                 URL tagFileJarUrl)
                          throws JasperException

Throws:
  `JasperException`

Method Detail

### addTaglib

    public void addTaglib(String uri,
                          TagLibraryInfoImpl taglib)

  Adds the given tag library with the given URI to the context-wide tag library cache.

  Parameters:
    `uri` - The tag library URI
    `taglib` - The tag library to add

### getTaglibs

    public ConcurrentHashMap<String,TagLibraryInfoImpl> getTaglibs()

  Gets the context-wide tag library cache.

  Returns:
    The context-wide tag library cache

### clearTaglibs

    public void clearTaglibs()

  Clears the context-wide tag library cache.

### clearTagFileJarUrls

    public void clearTagFileJarUrls()

  Clears the context-wide mappings from JAR packaged tag file paths to their corresponding URLs.

### getClassPath

    public String getClassPath()

  The classpath that is passed off to the Java compiler.

### setClassPath

    public void setClassPath(String classPath)

  The classpath that is passed off to the Java compiler.

### getClassLoader

    public ClassLoader getClassLoader()

  What class loader to use for loading classes while compiling this JSP?

### setClassLoader

    public void setClassLoader(URLClassLoader loader)

### getOutputDir

    public String getOutputDir()

  The output directory to generate code into. The output directory is make up of the scratch directory, which is provide in Options, plus the directory derived from the package name.

### createParser

    public Compiler createParser()
                          throws JasperException

  Create a compiler object for parsing only.

  Throws:
    `JasperException`

### createCompiler

    public Compiler createCompiler(boolean jspcMode)
                            throws JasperException

  Create a "Compiler" object.

  Throws:
    `JasperException`

### getCompiler

    public Compiler getCompiler()

### resolveRelativeUri

    public String resolveRelativeUri(String uri)

  Get the full value of a URI relative to this compilations context uses current file as the base.

### getResourceAsStream

    public InputStream getResourceAsStream(String res)
                                    throws JasperException

  Gets a resource as a stream, relative to the meanings of this context's implementation.

  Returns:
    a null if the resource cannot be found or represented as an InputStream.
  Throws:
    `JasperException`

### getResource

    public URL getResource(String res)
                    throws MalformedURLException

  Throws:
    `MalformedURLException`

### getResourcePaths

    public Set getResourcePaths(String path)
                         throws JasperException

  Throws:
    `JasperException`

### getRealPath

    public String getRealPath(String path)

  Gets the actual path of a URI relative to the context of the compilation.

### getTagFileJarUrls

    public ConcurrentHashMap<String,URL> getTagFileJarUrls()

  Gets the context-wide mappings from JAR packaged tag file paths to their corresponfing URLs.

### getTagFileJarUrl

    public URL getTagFileJarUrl()

  Returns the JAR file in which the tag file for which this JspCompilationContext was created is packaged, or null if this JspCompilationContext does not correspond to a tag file, or if the corresponding tag file is not packaged in a JAR.

### getServletClassName

    public String getServletClassName()

  Just the class name (does not include package name) of the generated class.

### setServletClassName

    public void setServletClassName(String className)

### getJspFile

    public String getJspFile()

  Path of the JSP URI. Note that this is not a file name. This is the context rooted URI of the JSP file.

### isErrorPage

    public boolean isErrorPage()

  Are we processing something that has been declared as an errorpage?

### setErrorPage

    public void setErrorPage(boolean isErrPage)

### isTagFile

    public boolean isTagFile()

### getTagInfo

    public TagInfo getTagInfo()

### setTagInfo

    public void setTagInfo(TagInfo tagi)

### isPrototypeMode

    public boolean isPrototypeMode()

  True if we are compiling a tag file in prototype mode. ie we only generate codes with class for the tag handler with empty method bodies.

### setPrototypeMode

    public void setPrototypeMode(boolean pm)

### getServletPackageName

    public String getServletPackageName()

  Package name for the generated class is make up of the base package name, which is user settable, and the derived package name. The derived package name directly mirrors the file heirachy of the JSP page.

### setServletPackageName

    public void setServletPackageName(String servletPackageName)

  The package name into which the servlet class is generated.

### getServletJavaFileName

    public String getServletJavaFileName()

  Full path name of the Java file into which the servlet is being generated.

### getOptions

    public Options getOptions()

  Get hold of the Options object for this context.

### getServletContext

    public ServletContext getServletContext()

### getRuntimeContext

    public JspRuntimeContext getRuntimeContext()

### getFullClassName

    public String getFullClassName()

  Full class name

### getJavaPath

    public String getJavaPath()

  Path of the Java file relative to the work directory.

### getClassFileName

    public String getClassFileName()

### getContentType

    public String getContentType()

  Get the content type of this JSP. Content type includes content type and encoding.

### setContentType

    public void setContentType(String contentType)

### getWriter

    public ServletWriter getWriter()

  Where is the servlet being generated?

### setWriter

    public void setWriter(ServletWriter writer)

### getTldLocation

    public String[] getTldLocation(String uri)
                            throws JasperException

  Gets the 'location' of the TLD associated with the given taglib 'uri'.

  Returns:
    An array of two Strings: The first element denotes the real path to the TLD. If the path to the TLD points to a jar file, then the second element denotes the name of the TLD entry in the jar file. Returns null if the given uri is not associated with any tag library 'exposed' in the web application.
  Throws:
    `JasperException`

### keepGenerated

    public boolean keepGenerated()

  Are we keeping generated code around?

### incrementRemoved

    public void incrementRemoved()

### isRemoved

    public boolean isRemoved()

### compile

    public void compile()
                 throws JasperException,
                        FileNotFoundException

  Throws:
    `JasperException`
    `FileNotFoundException`

### load

    public Class load()
               throws JasperException

  Throws:
    `JasperException`

### getJspLoader

    public ClassLoader getJspLoader()

### makeOutputDir

    public void makeOutputDir()

Copyright © 2008 Mort Bay Consulting. All Rights Reserved.